package com.danitheskunk.skunkstuff.Blocks;

import net.minecraft.core.BlockPos;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.DirectionalBlock;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.shapes.VoxelShape;

public class BlockGoban extends Block {
	private static final VoxelShape AABB = Block.box(0.0,
		0.0,
		0.0,
		16.0,
		8.0,
		16.0
	);

	public BlockGoban(Properties properties) {
		super(properties);
	}

	@Override
	public VoxelShape getShape(BlockState state, BlockGetter world,
		BlockPos pos, CollisionContext context) {
		return AABB;
	}

	protected void createBlockStateDefinition(StateDefinition.Builder<Block,
		BlockState> builder) {
		builder.add(DirectionalBlock.FACING);
	}

	public BlockState getStateForPlacement(BlockPlaceContext ctx) {
		return (BlockState) this.defaultBlockState().setValue(
			DirectionalBlock.FACING,
			ctx.getNearestLookingDirection().getOpposite()
		);
	}
}
