package com.danitheskunk.skunkstuff.Blocks;

import net.minecraft.client.gui.screens.inventory.HopperScreen;
import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.*;
import net.minecraft.world.item.ItemStack;
import org.jetbrains.annotations.Nullable;

public class MenuMailbox extends AbstractContainerMenu {

	private static final int CONTAINER_SIZE = 9;
	private final Container mailbox;
	public MenuMailbox(int syncId, Inventory playerInventory) {
		this(syncId, playerInventory, new SimpleContainer(CONTAINER_SIZE));
	}
	public MenuMailbox(int syncId, Inventory playerInventory, Container inventory) {
		super(Menus.MAILBOX, syncId);
		this.mailbox = inventory;
		checkContainerSize(inventory, CONTAINER_SIZE);
		inventory.startOpen(playerInventory.player);

		int i;
		for(i = 0; i < 3; ++i) {
			for(int j = 0; j < 3; ++j) {
				this.addSlot(new Slot(inventory, i + j * 3, 62 + i * 18,
					18 + j * 18));
			}
		}

		for(i = 0; i < 3; ++i) {
			for(int j = 0; j < 9; ++j) {
				this.addSlot(new Slot(playerInventory, j + i * 9 + 9,
					8 + j * 18, i * 18 + 84));
			}
		}

		for(i = 0; i < 9; ++i) {
			this.addSlot(new Slot(playerInventory, i, 8 + i * 18, 142));
		}

	}

	@Override
	public ItemStack quickMoveStack(Player player, int fromIndex) {
		ItemStack itemStack = ItemStack.EMPTY;
		Slot slot = (Slot)this.slots.get(fromIndex);
		if (slot != null && slot.hasItem()) {
			ItemStack itemStack2 = slot.getItem();
			itemStack = itemStack2.copy();
			if (fromIndex < this.mailbox.getContainerSize()) {
				if (!this.moveItemStackTo(itemStack2,
					this.mailbox.getContainerSize(), this.slots.size(), true)) {
					return ItemStack.EMPTY;
				}
			} else if (!this.moveItemStackTo(itemStack2, 0,
				this.mailbox.getContainerSize(), false)) {
				return ItemStack.EMPTY;
			}

			if (itemStack2.isEmpty()) {
				slot.set(ItemStack.EMPTY);
			} else {
				slot.setChanged();
			}
		}

		return itemStack;
	}

	@Override
	public boolean stillValid(Player player) {
		return mailbox.stillValid(player);
	}
}
